Whamcloud - gitweb
270214efaf7c76c94a35e29854895feb0aeda0fa
[fs/lustre-release.git] / contrib / lbuild / lbuild
1 #!/bin/bash
2
3 # vim:expandtab:shiftwidth=4:softtabstop=4:tabstop=4:
4
5 # this is an alternative FD for stdout, to be used especially when we are
6 # taking stdout from a function as it's return value.  i.e. foo=$(bar)
7 # this is a workaround until a version of bash where we can put xtrace
8 # on a specific FD
9 exec 3>&1; STDOUT=3
10
11 #set -x
12 xtrace="+x"
13 if [[ $SHELLOPTS = *xtrace* ]]; then
14     xtrace="-x"
15 fi
16 shopt -s extdebug
17
18 # Assume that lbuild's support files can be found in the same
19 # canonicalized path as this very script.
20 LBUILD_SCRIPT=$(readlink -f ${0})
21 LBUILD_DIR=${LBUILD_DIR:-$(dirname ${LBUILD_SCRIPT})}
22
23 # include the exit_traps library
24 . ${LBUILD_DIR}/exit_traps.sh
25 . ${LBUILD_DIR}/funcs.sh
26
27 # our children should die when we do
28 push_exit_trap "kill -INT -$$ || true" kill_children
29
30 # increment this if you have made a change that should force a new kernel
31 # to build built
32 #BUILD_GEN=1
33 #BUILD_GEN=2    # bz19952: remove -lustre tag from kernel RPM names
34 #BUILD_GEN=3    # bz19975: enable the building of src.rpms by default
35 #BUILD_GEN=4    # bz22281: use the git hash in the kernel extra version
36 #BUILD_GEN=5    # TT-107: don't cache the BUILD dir
37 BUILD_GEN=6     # TT-1092: don't cache the BUILD dir, to rebuild external OFED
38
39 TOPDIR=$PWD
40
41 KERNELDIR=
42 LINUX=
43 LUSTRE=
44 RELEASE=false
45 # XXX - some recent hacking has pretty much neutered this option.
46 #       search through this file for "-bb" and see how many places
47 #       simply don't account for this option
48 DO_SRC=true
49 DOWNLOAD=true
50 CANONICAL_TARGET=
51 TARGET=
52 TARGET_ARCH="$(uname -m)"
53 # change default behavior to only build for the current arch
54 TARGET_ARCHS="$TARGET_ARCH"
55 TARGET_ARCHS_ALL="$TARGET_ARCH"
56 [ "$TARGET_ARCH" = "i686" ] && TARGET_ARCHS_ALL="i686 i586 i386"
57 CONFIGURE_FLAGS=
58 EXTERNAL_PATCHES=
59 EXTRA_VERSION=
60 STAGEDIR=
61 TMPDIR=${TMPDIR:-"/var/tmp"}
62 TIMESTAMP=
63 # this is the dir that should be used to store reuse products
64 REUSEBUILD=
65 # should cached products be used or force rebuilding?
66 USE_BUILD_CACHE=true
67 # what does this do exactly?  does it imply no kernel build?
68 NORPM=false
69 IOKITRPM=true
70 OSDLDISKFSRPM=true
71 OSDZFSRPM=false
72 SMPTYPES="smp bigsmp default ''"
73 PATCHLESS=false
74 WITH_ZFS=""
75 XEN=false
76 LINUXOBJ=
77 DISTRO=
78 KERNELTREE=
79 # default to not adding -lustre- into the kernel RPM package names
80 KERNEL_LUSTRE_NAMING=false
81 # default not use kabi check.
82 USE_KABI=false
83
84 # patchless build
85 KERNELRPMSBASE=
86 RPMSMPTYPE=
87
88 # from target file
89 SERIES=
90 BASE_ARCHS=
91 BIGMEM_ARCHS=
92 BOOT_ARCHS=
93 JENSEN_ARCHS=
94 SMP_ARCHS=
95 BIGSMP_ARCHS=
96 PSERIES64_ARCHS=
97 UP_ARCHS=
98
99 # not in the target file any more
100 CONFIG=
101
102 # build the lustre-tests rpm?
103 LUSTRE_TESTS=true
104
105 DATE=$(date)
106
107 RPMBUILD=
108
109 export CC=${CC:-gcc}
110
111 # Readlink is not present on some older distributions: emulate it.
112 readlink() {
113     local path=$1 ll
114
115     if [ -L "$path" ]; then
116         ll="$(LC_ALL=C ls -l "$path" 2> /dev/null)" &&
117         echo "${ll/* -> }"
118     else
119         return 1
120     fi
121 }
122
123 usage() {
124     cat <<EOF
125 Usage: ${0##*/} [OPTION]... [-- <lustre configure options>]
126
127   --external-patches=EXTERNAL_PATCHES
128     Directory similar to lustre/lustre/kernel_patches/ that lbuild should
129     look for seres and config files in before looking in the lustre
130     tree.
131
132   --extraversion=EXTRAVERSION
133     Text to use for the rpm release and kernel extraversion.
134
135   --timestamp=TIMESTAMP
136     Date of building lustre in format YYYYMMDDhhmmss
137
138   --reusebuild=DIR
139     Try to reuse old kernel builds from DIR
140
141   --kernelrpm=DIR
142     Path to distro kernel RPM collection
143
144   --ccache
145     Use ccache
146
147   --norpm
148     Do not build RPMs (compile only mode)
149
150   --patchless
151     Build lustre client only
152
153   --distro=DISTRO
154     Which distro using. Autodetect by default
155
156   --kerneldir=KERNELDIR
157     Directory containing Linux source tarballs referenced by target
158     files.
159
160   --kerneltree=KERNELTREE
161     Directory containing dirs with Linux source tarballs referenced by target
162     files. Dir names in format kernel version ('2.6.9', etc.)
163
164   --linux=LINUX --with-linux=LINUX
165     Directory of Linux kernel sources.  When this option is used, only
166     Lustre modules and userspace are built.
167
168   --lustre=LUSTRE
169     Path to an existing lustre source tarball to use.
170
171   --nodownload
172     Do not try to download a kernel from downloads.hpdd.intel.com
173
174   --nosrc
175     Do not build a .src.rpm, a full kernel patch, or a patched kernel
176     tarball.
177
178   --ldiskfs
179     Build with ldiskfs support. (Deprecated, always true)
180
181   --noiokit
182     Do not build lustre-iokit RPM. Now true by default
183
184   --publish
185     Unused.
186
187   --release
188     Specifies that the files generated do not include timestamps, and
189     that this is an official release.
190
191   --disable-zfs
192     Build Lustre without ZFS.
193
194   --src
195     Build a .src.rpm, a full kernel patch, and a patched kernel tarball.
196
197   --stage=DIR
198     Directory used to stage packages for release.  RPMs will be placed
199     more or less in DIR/<target>-<arch>, and the tarball will be
200     placed in DIR.
201
202   --target=TARGET
203     The name of the target to build.  The available targets are listed
204     below.
205
206   --target-archs=TARGET_ARCHS
207     A (space delimited) list of architectures to build.  By default,
208     all of the archs supported by the TARGET will be built, in
209     addition to a .src.rpm.  This option can limit those, for machines
210     that can only build certain archs or if you only want a certain
211     arch built (for testing, or a one-off kernel).
212
213     Also note that by using a non-"base" arch (eg, i386) only kernels
214     will be built - there will be no lustre-lite-utils package.
215
216   --xen
217     Builds a Xen domX kernel.
218
219   --set-value
220     Sets a variable to a given value.
221
222 EOF
223
224 #   list_targets
225
226     fatal "$1" "$2"
227 }
228
229 # canonicalize a relative path to a file
230 canon_filepath() {
231     local PATH="$1"
232
233     if [ ! -f "$PATH" ]; then
234         return 1
235     fi
236
237     local FILE=${PATH##*/}
238     local DIR=${PATH%/*}
239
240     echo $(canon_path "$DIR")/$FILE
241     return 0
242 }
243
244 # canonicalize a relative path to a dir
245 canon_path() {
246     local PATH="$1"
247
248     if [ ! -d "$PATH" ]; then
249         return 1
250     fi
251
252     pushd "$PATH" >/dev/null || return 1
253     local CANONPATH=$PWD
254     popd >/dev/null
255
256     echo "$CANONPATH"
257     return 0
258 }
259
260 check_options() {
261
262     if [ -z "$LUSTRE" -o ! -r "$LUSTRE" ]; then
263         usage 1 "Could not find Lustre source tarball '$LUSTRE'."
264     fi
265
266     if [ -z "$DISTRO" ] ; then
267         DISTRO=$(autodetect_distro)
268         # remove separator
269         DISTRO=${DISTRO/-/}
270     fi
271     DISTROMAJ=${DISTRO%%.*}
272
273     [ -z "$TARGET" ] && TARGET=$(autodetect_target "$DISTRO")
274
275     if [ -z "$LINUX" ]; then
276         [ "$KERNELDIR" -o "$KERNELTREE" ] || \
277             usage 1 "A kernel directory must be specified with --kerneldir or --kerneltree."
278
279         [ -d "$KERNELDIR" -o -d "$KERNELTREE" ] || \
280             usage 1 "$KERNELDIR and $KERNELTREE are not a directory."
281
282 #       TARGET_FILE="$TOPDIR/lustre/kernel_patches/targets/$TARGET.target"
283 #       [ -r "$TARGET_FILE" ] || \
284 #               usage 1 "Target '$TARGET' was not found."
285     fi
286
287     case $TARGET in
288         3.12-sles12)
289             CANONICAL_TARGET="sles12"
290             ;;
291         3.10-rhel7)
292             CANONICAL_TARGET="rhel7"
293             ;;
294         2.6-rhel6*)
295             CANONICAL_TARGET="rhel6"
296             ;;
297         2.6-rhel5)
298             CANONICAL_TARGET="rhel5"
299             ;;
300         2.6-rhel4)
301             CANONICAL_TARGET="rhel-2.6"
302             ;;
303         2.6-suse)
304             CANONICAL_TARGET="sles-2.6"
305             ;;
306         2.6-sles10)
307             CANONICAL_TARGET="sles10-2.6"
308             ;;
309         2.6-sles11 | 3.0-sles11)
310             CANONICAL_TARGET="sles11"
311             ;;
312         2.6-oel5)
313             CANONICAL_TARGET="oel5"
314             ;;
315         hp_pnnl-2.4)
316             CANONICAL_TARGET="hp-pnnl-2.4"
317             ;;
318         2.6-vanilla \
319             | suse-2.4.21-2 \
320             | rh-2.4 \
321             | rhel-2.4 \
322             | sles-2.4 \
323             | 2.6-patchless)
324                 CANONICAL_TARGET="$TARGET"
325                 ;;
326     esac
327
328     local timestampnodig=$(echo $TIMESTAMP | sed -e s/[0-9]*//g)
329     [ "$timestampnodig" = "" ] || TIMESTAMP=$(date -d "$DATE" "+%Y%m%d%H%M%S")
330     local timestamplength="${#TIMESTAMP}"
331     if [ $timestamplength -eq 12 ]; then
332         TIMESTAMP="${TIMESTAMP}00"
333     elif [ $timestamplength -ne 14 ]; then
334         TIMESTAMP=$(date -d "$DATE" "+%Y%m%d%H%M%S")
335     fi
336
337     RPMBUILD=$(which rpmbuild 2>/dev/null | head -1)
338     if [ ! "$RPMBUILD" -o "$RPMBUILD" == "" ]; then
339         RPMBUILD=$(which rpm 2>/dev/null | head -1)
340         if [ ! "$RPMBUILD" -o "$RPMBUILD" == "" ]; then
341             usage 1 "Could not find binary for making rpms (tried rpmbuild and rpm)."
342         fi
343     fi
344
345     if [ -n "$CCACHE" ]; then
346         which "$DISTCC" &>/dev/null && export DISTCC RPM_BUILD_NCPUS
347
348         if which "$CCACHE" &>/dev/null; then
349             local ccache=$(which "$CCACHE")
350             local bindir="$TOPDIR/bin"
351
352             if [ ! -d $bindir ]; then
353                 mkdir -p $bindir || fatal 1 "error trying to create $bindir"
354             else
355                 rm ${bindir}/* > /dev/null 2>&1 || true
356             fi
357             ln -s "$ccache" ${bindir}/ccache
358             ln -s "$ccache" ${bindir}/cc
359             ln -s "$ccache" ${bindir}/$CC
360             export PATH=$bindir:$PATH
361             export CCACHE && export CC="ccache $CC"
362             # zero the cache so we can see how effective we are being with it
363             echo -n "ccache "
364             ccache -z
365
366             # get some ccache stats when we are done
367             push_exit_trap '[ -n "$CCACHE" ] && ccache -s' "ccache_summary"
368             # should remove the ccache trap if lbuild is interrupted
369             trap 'echo "Received an INT TERM or HUP signal, terminating."; delete_exit_trap "ccache_summary"; exit 1' INT TERM HUP
370         fi
371     fi
372
373     return 0
374
375 }
376
377 # compare two versions $1 and $2. if $1 < $2, return 0 otherwise return 1.
378 compare_version () {
379     [[ $1 == $2 ]] && return 1
380     local IFS=.
381     local i val1=($1) val2=($2)
382
383     # padding zero to val1 if it needs
384     for ((i=${#val1[@]}; i<${#val2[@]}; i++)); do
385         val1[i]=0
386     done
387     for ((i=0; i<${#val1[@]}; i++)); do
388         [[ -z ${val2[i]} ]] && return 1
389
390         if [[ ${val1[i]} < ${val2[i]} ]]; then
391             return 0
392         elif [[ ${val1[i]} > ${val2[i]} ]]; then
393             return 1
394         fi
395     done
396 }
397
398 uniqify() {
399
400     echo $(echo "$*" | xargs -n 1 | sort -u)
401
402 }
403
404 fetch_url() {
405     local url="$1"
406     local target="$2"
407
408     if [ -z "$target" ]; then
409         fatal 1 "fetch_url() called without a target to fetch to"
410     fi
411
412     if [ -d $target ]; then
413         target+="/${url##*/}"
414     fi
415
416     local rc=0
417     if which wget >/dev/null 2>&1; then
418         if ! wget -nv "$url" -O "$target"; then
419             rc=${PIPESTATUS[0]}
420         fi
421     elif which curl >/dev/null 2>&1; then
422         if ! curl -n -L -s -o "$target" "$url"; then
423             rc=${PIPESTATUS[0]}
424         fi
425     else
426         fatal 1 "Could not find either wget or curl to fetch URLs."
427     fi
428
429     return $rc
430
431 }
432
433 download_srpm() {
434     local target=$1
435     local srpm=$2
436     local force="${3:-false}"
437
438     if $force || [ ! -r "$KERNELDIR/$srpm" ] ||
439        [ ! -s "$KERNELDIR/$srpm" ]; then
440         if $DOWNLOAD; then
441             local location="https://downloads.hpdd.intel.com/public/kernels/$target/old"
442             # get the location from a distro specific method if it exists
443             if type -p kernel_srpm_location; then
444                 location=$(kernel_srpm_location)
445             fi
446             echo "Downloading $location/$srpm..."
447             if ! fetch_url "$location/$srpm" "$KERNELDIR/$srpm" 2>&1 ||
448                [ ! -s "$KERNELDIR/$srpm" ]; then
449                 rm -f $KERNELDIR/$srpm
450                 # punt to a distro specific method if it exists
451                 if ! type -p download_srpm-$DISTROMAJ; then
452                     fatal 1 "Could not download target $target's kernel SRPM $srpm from $location."
453                 else
454                     if ! download_srpm-$DISTROMAJ "$target" "$srpm" "$force"; then
455                         fatal 1 "Could not download target $target's kernel SRPM $srpm using download_srpm-$DISTROMAJ."
456                     fi
457                 fi
458             fi
459         else
460             fatal 1 "$srpm not found in directory $KERNELDIR."
461         fi
462     fi
463
464 }
465
466 download_file() {
467     local from="$1"
468     local to="$2"
469     local force="$3"
470
471     local file=${from##*/}
472
473     if [ -d $to ]; then
474         to="$to/$file"
475     fi
476
477     local semaphore="$to-downloading"
478
479     is_downloading() {
480         if [ ! -f $semaphore ]; then
481             return 1
482         fi
483
484         # make sure the download has not been aborted
485         local now=$(date +%s)
486         local file_mtime=$(stat -c %Y "$to")
487         local staleness=$((now - file_mtime))
488         # let's assume an active download will write at least once a minute
489         if [ $staleness -gt 60 ]; then
490             return 1
491         fi
492
493         return 0
494     }
495
496     is_downloaded() {
497         # if the semaphore file exists, the file is either still downloading
498         # or a download was aborted and we cannot trust the target file
499         if [ -f $semaphore ]; then
500             return 1
501         fi
502
503         if ! is_downloading && [ -r "$to" ] && [ -s "$to" ]; then
504             return 0
505         fi
506
507         return 1
508     }
509
510     if $force || ! is_downloaded; then
511         if is_downloading; then
512             echo "Somebody else is downloading $from..."
513             while is_downloading; do
514                 echo "Waiting for $to to finish downloading"
515                 sleep 60
516             done
517             if is_downloaded; then
518                 return 0
519             else
520                 echo "The download we were waiting for seems to have been aborted"
521             fi
522
523         fi
524
525         if $DOWNLOAD; then
526             echo "Downloading $from..."
527             # flag others so they don't try to download also
528             push_exit_trap "rm -f $to $semaphore" "download"
529             touch $semaphore
530             if ! fetch_url "$from" "$to" || [ ! -s "$to" ]; then
531                 # the trap will remove the files via the fatal below
532                 fatal 1 "Could not download ${to##*/} from ${from%/*}/."
533             fi
534             rm -f $semaphore
535             delete_exit_trap "download"
536         else
537             fatal 1 "${to##*/} not found in directory ${to%/*}."
538         fi
539     fi
540
541     return 0
542
543 }
544
545 download_ofed() {
546     local force="${1:-false}"
547
548     if [ -z "$OFED_VERSION" -o "$OFED_VERSION" = "inkernel" ]; then
549         return 0
550     fi
551
552     local OFED_BASE_VERSION=$OFED_VERSION
553     if [[ $OFED_VERSION = *.*.*.* ]]; then
554         OFED_BASE_VERSION=${OFED_VERSION%.*}
555     fi
556
557     local location="https://www.openfabrics.org/downloads/OFED/ofed-${OFED_BASE_VERSION}/"
558
559     if [[ $OFED_VERSION = *-[rR][cC][0-9] ]]; then
560         local Mmv
561         Mmv=${OFED_VERSION%%-[rR][cC][0-9]}
562         location="https://www.openfabrics.org/downloads/OFED/ofed-${Mmv}/"
563     fi
564
565     if [[ $OFED_VERSION = daily-* ]]; then
566         local Mmv
567         Mmv=${OFED_VERSION/daily-/}
568         daily=${OFED_VERSION##$Mmv-}
569         location="https://www.openfabrics.org/downloads/OFED/ofed-${Mmv}-daily/"
570         # find the filename for the version for the date specified
571         OFED_VERSION=$(curl -s "$location" | sed -nre "/${Mmv}-/s/.*href=\"OFED-(${Mmv}-[0-9]{8,8}-[0-9]{4,4}).tgz.*$/\1/p" | tail -1)
572         if [ -z "$OFED_VERSION" ]; then
573             fatal 1 "Could not determine the filename of the OFED snapshot for ${daily}"
574         fi
575     fi
576
577     local file="OFED-${OFED_VERSION}.tgz"
578     download_file "$location/$file" "$KERNELTREE" "$force"
579
580 }
581
582 load_target() {
583
584     EXTRA_VERSION_save="$EXTRA_VERSION"
585     for patchesdir in "$EXTERNAL_PATCHES" \
586                       "$TOPDIR/lustre/lustre/kernel_patches"; do
587         TARGET_FILE="$patchesdir/targets/$TARGET.target"
588         [ -r "$TARGET_FILE" ] && break
589     done
590     [ -r "$TARGET_FILE" ] || fatal 1 "Target $TARGET was not found."
591
592     echo "Loading target config file $TARGET.target..."
593
594     # if the caller specified an OFED_VERSION it should override whatever
595     # the target file specifies
596     local env_OFED_VERSION="$OFED_VERSION"
597
598     . "$TARGET_FILE"
599
600     if [ -n "$env_OFED_VERSION" ]; then
601         OFED_VERSION="$env_OFED_VERSION"
602     fi
603
604     # doesn't make any sense to build OFED for xen domX's
605     if $XEN; then
606         OFED_VERSION=""
607     fi
608
609     # XXX - set_rpm_smp_type is an ugly undeterministic hack.  it needs to
610     #       go away and the target just specify the $RPMSMPTYPE
611     [ -z "$RPMSMPTYPE" ] && set_rpm_smp_type
612
613     # CC might have been overwritten in TARGET_FILE
614     if [[ $CC != ccache\ * ]] && which "$CCACHE" &>/dev/null; then
615         export CCACHE && export CC="ccache $CC"
616     fi
617
618     if [ ! "$KERNELTREE" = "" ] && [ -d "$KERNELTREE" ]; then
619         KERNELDIR="$KERNELTREE/${lnxmaj}"
620         [ -d "$KERNELDIR" ] || mkdir "$KERNELDIR"
621     fi
622
623     # verify the series is available
624     if [ "$SERIES" ]; then
625         for series in $SERIES; do
626             for patchesdir in "$EXTERNAL_PATCHES" "$TOPDIR/lustre/lustre/kernel_patches"; do
627                 [ -r "$patchesdir/series/$series" ] && continue 2
628             done
629             fatal 1 "Target $TARGET's series $SERIES could not be found.\nSearched:\n\t$EXTERNAL_PATCHES/series\n\t$TOPDIR/lustre/lustre/kernel_patches/series."
630         done
631     fi
632
633     # set the location of the .config file
634     local XENPOSTFIX=""
635     if $XEN; then
636         XENPOSTFIX="-xen"
637     fi
638
639     if [ -f $TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET-$TARGET_ARCH.config ]; then
640         CONFIG_FILE="$TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET$XENPOSTFIX-$TARGET_ARCH.config"
641     fi
642
643     local lnxrelnew=${lnxrel//-/_}
644
645     # remember the EXTRA_VERSION before we diddle it here
646     # XXX - we really should not diddle with any values read in from the
647     #       target file.  if we want to modify a value, we should create
648     #       a new variable.
649     PRISTINE_EXTRA_VERSION=$EXTRA_VERSION
650
651     if ! $PATCHLESS && [ ! -f "$CONFIG_FILE" ]; then
652         fatal 1 "Config file for target $TARGET missing from $TOPDIR/lustre/lustre/kernel_patches/kernel_configs/."
653     fi
654
655     if [ "$EXTRA_VERSION_save" ]; then
656         EXTRA_VERSION="$EXTRA_VERSION_save"
657     elif ! $RELEASE; then
658         # if there is no patch series, then this is not a lustre specific
659         # kernel.  don't make it look like one
660         if $PATCHLESS || [ -n "$SERIES" ]; then
661             EXTRA_VERSION=$(echo $EXTRA_VERSION | sed -e "s/\(.*_lustre\)\..*/\1/")
662             if ! $PATCHLESS && [ -n "$BUILDID" ]; then
663                 EXTRA_VERSION="${EXTRA_VERSION}.${BUILDID}"
664             fi
665         fi
666     fi
667     # EXTRA_VERSION=${EXTRA_VERSION//-/_}
668
669     ALL_ARCHS="$BASE_ARCHS $BIGMEM_ARCHS $BOOT_ARCHS $JENSEN_ARCHS $SMP_ARCHS $BIGSMP_ARCHS $PSERIES64_ARCHS $UP_ARCHS"
670
671     BUILD_ARCHS=
672     for arch in $(uniqify "$ALL_ARCHS"); do
673         if [ -z "$TARGET_ARCHS" ] ||
674            [[ \ $TARGET_ARCHS\  = *\ $arch\ * ]]; then
675             BUILD_ARCHS="$BUILD_ARCHS $arch"
676         fi
677     done
678     [ "$BUILD_ARCHS" ] || usage 1 "No available target archs to build."
679     echo "Building for: $BUILD_ARCHS"
680 }
681
682 tarflags() {
683     local file="$1"
684
685     echo -n '--wildcards '
686     case "$file" in
687         '')
688             fatal 1 "tarflags(): File name argument missing."
689             ;;
690         *.tar.gz | *.tgz)
691             echo '-zxf'
692             ;;
693         *.tar.bz2)
694             echo '-jxf'
695             ;;
696         *.tar)
697             echo '-xf'
698             ;;
699         *)
700             fatal 1 "tarflags(): Unrecognized tar extension in file: $1"
701             ;;
702     esac
703
704 }
705
706 untar() {
707     local tarfile="$1"
708     shift
709     local extractfile="$@"
710
711     echo "Untarring ${tarfile##*/}..."
712     tar $(tarflags "$tarfile") "$tarfile" $extractfile
713
714 }
715
716 unpack_ofed() {
717
718     if ! untar "$KERNELTREE/OFED-${OFED_VERSION}.tgz"; then
719         return 1
720     fi
721     [ -d OFED ] || ln -sf OFED-[0-9].[0-9]* OFED
722
723 }
724
725 unpack_lustre() {
726
727     untar "$LUSTRE" || fatal 1 "Error unpacking Lustre tarball"
728     [ -d lustre ] || ln -sf lustre-[0-9].[0-9]* lustre
729
730 }
731
732 do_patch_linux() {
733
734     local do_patch=${1:-true}
735
736     FULL_PATCH="$PWD/lustre-kernel-${TARGET}-${EXTRA_VERSION}.patch"
737     [ -f "$FULL_PATCH" ] && rm -f "$FULL_PATCH"
738     $do_patch && pushd linux >/dev/null
739     for series in $SERIES; do
740         echo -n "Applying series $series:"
741         for patchesdir in "$EXTERNAL_PATCHES" "$TOPDIR/lustre/lustre/kernel_patches"; do
742             [ -r "$patchesdir/series/$series" ] || continue
743             SERIES_FILE="$patchesdir/series/$series"
744             for patch in $(<"$SERIES_FILE"); do
745                 echo -n " $patch"
746                 PATCH_FILE="$patchesdir/patches/$patch"
747                 [ -r "$PATCH_FILE" ] || \
748                     fatal 1 "Patch $patch does not exist in Lustre tree."
749                 cat "$PATCH_FILE" >> "$FULL_PATCH" || {
750                     rm -f $FULL_PATCH
751                     fatal 1 "Error adding patch $patch to full patch."
752                 }
753                 if $do_patch; then
754                     patch -s -p1 < "$PATCH_FILE" 2>&1 || {
755                         rm -f $FULL_PATCH
756                         fatal 1 "Error applying patch $patch."
757                     }
758                 fi
759             done
760             break
761         done
762         echo
763     done
764     $do_patch && popd >/dev/null
765     echo "Full patch has been saved in ${FULL_PATCH##*/}."
766
767 }
768
769 build_lustre() {
770     local linux="$1"
771     local linuxobj="$2"
772
773     cp "$LUSTRE" SOURCES
774
775     pushd lustre >/dev/null
776
777     if ! build_lustre_dkms; then
778         popd >/dev/null # pushd lustre
779         return 255
780     fi
781
782     echo "Building Lustre RPMs for: $BUILD_ARCHS..."
783     local targets arch
784     for arch in $BUILD_ARCHS; do
785         targets="--target $arch $targets"
786     done
787
788     local rpmbuildopt='-tb'
789     if $NORPM; then
790         rpmbuildopt='-tc'
791         echo NORPM mode. Only compiling.
792     fi
793
794     # If server we now build the spl and zfs modules against the lustre kernel.
795     # These are required prior to the building of lustre server. Client does
796     # not require spl/zfs. Use !PATCHLESS to indicate server which follows the
797     # line above so is at least consistant.
798     if [ $PATCHLESS == false ] && [ "x$WITH_ZFS" == "x" ]; then
799         if ! build_spl_zfs; then
800             popd >/dev/null # pushd lustre
801             return 255
802         fi
803     fi
804
805     if $PATCHLESS; then
806         RPMBUILD_DEFS="$RPMBUILD_DEFS --without servers"
807         if [ -n "$CROSS_SUFFIX" ]; then
808             RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"lustre_name lustre-client$CROSS_SUFFIX\""
809         fi
810     fi
811
812     # ditto for the lustre-tests boolean
813     if ! $LUSTRE_TESTS; then
814         RPMBUILD_DEFS="$RPMBUILD_DEFS --without lustre_tests"
815     fi
816
817     if ! $IOKITRPM; then
818         RPMBUILD_DEFS="$RPMBUILD_DEFS --without lustre_iokit"
819     fi
820
821     local osd_zfs=""
822     if $OSDZFSRPM; then
823         osd_zfs="yes"
824     fi
825
826     local osd_ldiskfs=""
827     if $OSDLDISKFSRPM; then
828         osd_ldiskfs="yes"
829     fi
830
831     RPMBUILD_DEFS="$RPMBUILD_DEFS ${FIND_REQUIRES:+--define \"__find_requires $FIND_REQUIRES\"}"
832     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"configure_args ${CONFIGURE_FLAGS}\""
833     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"kdir $linux\""
834     RPMBUILD_DEFS="$RPMBUILD_DEFS ${linuxobj:+--define \"kobjdir $linuxobj\"}"
835     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_tmppath $TMPDIR\""
836     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_topdir $TOPDIR\""
837
838     # allow environment setting to override ldiskfs series selection
839     [ -n "$LDISKFS_SERIES" ] && export LDISKFS_SERIES
840
841     eval $RPMBUILD $targets $rpmbuildopt "$LUSTRE" $RPMBUILD_DEFS \
842         ${osd_zfs:+--with zfs} \
843         ${osd_ldiskfs:+--with ldiskfs} 2>&1 || \
844         fatal 1 "Error building rpms for $BUILD_ARCHS."
845
846     if $DO_SRC; then
847         if ! eval $RPMBUILD -ts "$LUSTRE" $RPMBUILD_DEFS 2>&1; then
848             popd >/dev/null
849             return 255
850         fi
851     fi
852     popd >/dev/null
853
854 }
855
856 # Only zfs Lustre DKMS Server is supported
857 build_lustre_dkms() {
858     local ver=$(eval echo  $(awk '/LUSTRE_VERSION_STRING/ {print $3}'  lustre/include/lustre_ver.h))
859     echo "Building Lustre DKMS RPMs for: $BUILD_ARCHS..."
860     ./configure --enable-dist || return 255
861
862     if $PATCHLESS; then
863         $RPMBUILD --define="_topdir $TOPDIR" --without servers -bs lustre-dkms.spec || return 255
864         $RPMBUILD --rebuild --define="_topdir $TOPDIR" --without servers $TOPDIR/SRPMS/lustre-client-dkms-$ver-*.src.rpm || return 255
865     else
866         $RPMBUILD --define="_topdir $TOPDIR" -bs lustre-dkms.spec || return 255
867         $RPMBUILD --rebuild --define="_topdir $TOPDIR" $TOPDIR/SRPMS/lustre-dkms-$ver-*.src.rpm || return 255
868     fi
869     return 0
870 }
871
872 ###
873 # build_spl_zfs
874 #
875 # Fetch spl/zfs from the git repo and prepare for lustre build
876 #
877 # Overrides:
878 #   SPLZFSGITREPO - URI of directory where spl.git and zfs.git are located
879 #   SPLZFSTAG     - Tag to checkout of clone repositories
880 #   SPLZFSVER     - Version to checkout of both (format zfs/spl-$SPLZFSVER)
881 #
882 # return 0 if successful, else 255
883 build_spl_zfs() {
884     # make sure the RPM build environment is set up
885     pushd $TOPDIR
886     create_rpmbuild_dirs
887     popd
888
889     # The spl/zfs spec files expect RPM_BUILD_ROOT to point to the root of the
890     # destination for the rpms
891     export RPM_BUILD_ROOT=$TOPDIR
892     SPLZFSVER=${SPLZFSVER:-0.6.4.2}
893     SPLZFSTAG=${SPLZFSTAG:-}
894
895     # The files expect a kver to be set to the kernel version .
896     local kver=$(find_linux_release)
897
898     # build and install the spl and zfs (and -devel) RPMs for lustre to use
899     local pkg
900     for pkg in spl zfs; do
901
902         local rpmpkg
903
904         [ "$pkg" == "zfs" ] && spldir="$(ls -d $TOPDIR/usr/src/spl-*/|tail -1)"
905
906         # need to fetch the repo in order to build it.
907         # default to github but allow override
908         git clone ${SPLZFSGITREPO:-"https://github.com/zfsonlinux"}/$pkg.git $pkg 2>&1
909
910         pushd $pkg || return 255
911         if [ -n "$SPLZFSTAG" ]; then
912             git checkout $SPLZFSTAG
913         else
914             git checkout -b lbuild $pkg-$SPLZFSVER
915         fi
916
917         # This differentiates between older zfs versions
918         if [ -f $pkg-modules.spec.in ]; then
919             rpmpkg=$pkg-modules
920             specdir=.
921             speclist="$pkg.spec $rpmpkg.spec"
922         else
923             rpmpkg=kmod-$pkg-devel
924             specdir=rpm/generic
925             speclist="$pkg.spec $pkg-kmod.spec $pkg-dkms.spec"
926         fi
927
928         sh autogen.sh || return 255
929
930         if  ! ./configure --with-linux=${LINUX} --with-linux-obj=${LINUXOBJ:-$LINUX} \
931                           ${spldir:+--with-spl="${spldir}"} 2>&1 ||
932             ! make dist 2>&1; then
933             popd
934             return 255
935         fi
936         popd
937
938         ln -f $pkg/$pkg-*.tar.gz $TOPDIR/SOURCES ||
939            error "failed to link $pkg/$pkg-*.tar.gz into $TOPDIR/SOURCES"
940         if [ -f $pkg/scripts/kmodtool ]; then
941             ln -f $pkg/scripts/kmodtool $TOPDIR/SOURCES/
942         fi
943
944         local rpmb
945         if $DO_SRC; then
946             rpmb=-ba
947         else
948             rpmb=-bb
949         fi
950
951         # set search dir for our own kmodtool to find correct
952         # directories
953         export KERNELSOURCE=$(dirname ${LINUX})
954         # Manually build rpms
955         for spec in $speclist; do
956             echo "Building RPMs from $pkg/$specdir/$spec"
957             if ! $RPMBUILD $rpmb $pkg/$specdir/$spec \
958                 --nodeps -v \
959                 --define "require_kdir ${LINUX}" \
960                 ${LINUXOBJ:+--define "require_kobj ${LINUXOBJ}"} \
961                 ${spldir:+--define "require_spldir ${spldir}"} \
962                 --define "kver $kver" \
963                 --define "kernels $kver" \
964                 --define "_tmppath /var/tmp" \
965                 --define "kernelbuildroot $TOPDIR/reused" \
966                 --define "_topdir $TOPDIR" 2>&1; then
967                 return 255
968             fi
969         done
970
971         # We have built the rpms for the package. Now we need to extract the
972         # contained files so we can build further things against them
973         local rpms=$(ls -1 $TOPDIR/RPMS/*/$rpmpkg-*.rpm)
974
975         # cpio only extract to pwd so we need to go there.
976         pushd $TOPDIR
977         local rpm
978         for rpm in $rpms; do
979             rpm2cpio $rpm | cpio -id
980         done
981
982         if [ "$pkg" == "zfs" ]; then
983             # We also need to extract both the zfs and zfs-devel rpms
984             # the zfs rpm is needed because it has the actual libraries in
985             # it and the zfs-devel rpm only has unversioned symlinks to the
986             # libraries in the zfs rpm
987             # this will all change one day when we have a libzfs rpm per
988             # https://github.com/zfsonlinux/zfs/issues/2329
989             # and it looks like it could be one day soon:
990             # https://github.com/zfsonlinux/zfs/pull/2341
991             local devel_rpms=$(ls -1 $TOPDIR/RPMS/*/{$pkg-devel,$pkg-$SPLZFSVER,lib*}-*.rpm)
992             for rpm in $devel_rpms; do
993                 rpm2cpio $rpm | cpio -id
994             done
995             CONFIGURE_FLAGS="--with-$pkg-devel=$TOPDIR ${CONFIGURE_FLAGS}"
996         fi
997         popd
998
999         CONFIGURE_FLAGS="--with-$pkg=$(ls -d $TOPDIR/usr/src/$pkg-*/|tail -1) ${CONFIGURE_FLAGS}"
1000         CONFIGURE_FLAGS="--with-$pkg-obj=$(ls -d $TOPDIR/usr/src/$pkg-*/$kver*|tail -1) ${CONFIGURE_FLAGS}"
1001     done
1002
1003     OSDZFSRPM=true
1004
1005     return 0
1006 }
1007
1008 stage() {
1009
1010     [ "$STAGEDIR" ] || return 0
1011
1012     for arch in $BUILD_ARCHS; do
1013         rpmdir="${STAGEDIR}/${CANONICAL_TARGET}-${arch}"
1014         echo "${0##*/}: Copying RPMs into ${rpmdir}"
1015         mkdir -p "${rpmdir}"
1016         cp -v RPMS/${arch}/*.rpm "${rpmdir}"
1017         if [ -d RPMS/noarch ]; then
1018             cp -v RPMS/noarch/*.rpm "${rpmdir}"
1019         fi
1020     done
1021
1022     cp -v "$LUSTRE" "$STAGEDIR"
1023
1024 }
1025
1026 set_rpm_smp_type() {
1027
1028     local infact_arch="${TARGET_ARCH}"
1029
1030     RPMSMPTYPE=""
1031     [ "$infact_arch" == "i586" ] && infact_arch="i686"
1032
1033     local smp_type
1034     for smp_type in $SMP_ARCHS; do
1035         [ $infact_arch == $smp_type ] && RPMSMPTYPE=smp && break
1036     done
1037
1038     for smp_type in $BIGSMP_ARCHS; do
1039         [ $infact_arch == $smp_type ] && RPMSMPTYPE=bigsmp && break
1040     done
1041
1042     for smp_type in $PPC64_ARCHS; do
1043         [ $infact_arch == $smp_type ] && RPMSMPTYPE=ppc64 && break
1044     done
1045
1046     for smp_type in $DEFAULT_ARCHS; do
1047         [ $infact_arch == $smp_type ] && RPMSMPTYPE=default && break
1048     done
1049
1050 }
1051
1052 # This function takes a linux include tree and digs out the linux release
1053 # from it. It is never called directly, only called from the distro
1054 # specific function find_linux_release() in lbuild-{rhel,sles}.
1055 _find_linux_release() {
1056     local SRC="$1"
1057     local LINUXRELEASEHEADER=""
1058
1059     LINUXRELEASEHEADER=$SRC/include/linux/version.h
1060     if [ -s $SRC/include/generated/utsrelease.h ]; then
1061         LINUXRELEASEHEADER=$SRC/include/generated/utsrelease.h
1062     elif [ -s $SRC/include/linux/utsrelease.h ]; then
1063         LINUXRELEASEHEADER=$SRC/include/linux/utsrelease.h
1064     fi
1065
1066     if [ ! -s $LINUXRELEASEHEADER ]; then
1067         fatal 1 "could not find UTS_RELEASE"
1068     fi
1069
1070     sed -ne 's/#define UTS_RELEASE "\(.*\)"$/\1/p' $LINUXRELEASEHEADER
1071 }
1072
1073 # unpack kernel(/source/devel) RPM
1074 #
1075 # This function and it's setting of $LINUX and $LINUXOBJ is a total hack that
1076 # needs to completely refactored.  It completely ingores that $BUILD_ARCHS may
1077 # contain a list of arches for which rpmbuild commands (including the one for
1078 # lustre itself)
1079 unpack_linux_devel_rpm() {
1080     local kernelrpm="${1}"
1081
1082     [ -f "$kernelrpm" ] || return 255
1083     [ -d $TOPDIR/reused ] || mkdir $TOPDIR/reused || return 255
1084
1085     pushd $TOPDIR/reused &>/dev/null || return 255
1086
1087     if ! rpm2cpio < "$kernelrpm" | cpio -id > /dev/null 2>&1; then
1088         return 255
1089     fi
1090
1091     # call a distro specific hook, if available
1092     if type -p unpack_linux_devel_rpm-$DISTROMAJ; then
1093         if ! unpack_linux_devel_rpm-$DISTROMAJ "$kernelrpm"; then
1094             return 255
1095         fi
1096     fi
1097
1098     popd &>/dev/null
1099
1100     find_linux_devel_paths $TOPDIR/reused
1101
1102     return 0
1103
1104 }
1105
1106 build_kernel_ib() {
1107     local linux="$1"
1108     local kib_prefix="$2"
1109     local kib_rpm="$3"
1110
1111     # build kernel-ib{,-devel}/compat-rdma{,-devel}
1112     local K_SRC="K_SRC"
1113     # ofed 1.3 had a bug in the rpm spec
1114     if [ "$OFED_VERSION" = "1.3" ]; then
1115         K_SRC="KSRC"
1116     fi
1117
1118     local OFED_CORE="--with-core-mod --with-ipoib-mod --with-user_mad-mod --with-user_access-mod --with-addr_trans-mod"
1119     local OFED_HARDWARE="--with-mthca-mod --with-mlx4-mod --with-mlx4_en-mod --with-cxgb3-mod --with-nes-mod --with-qib-mod"
1120
1121     if compare_version $OFED_VERSION 3.0; then
1122         OFED_CORE="$OFED_CORE --with-madeye-mod --with-rds-mod"
1123     else
1124         OFED_HARDWARE="$OFED_HARDWARE --with-mlx5-mod --with-cxgb4-mod --with-ocrdma-mod --with-qib-mod"
1125     fi
1126
1127     # some I/B drivers are architecture dependent and kernel-ib's configure
1128     # does not figure it out for us ~sigh~
1129     case "$TARGET_ARCH" in
1130         ppc64)
1131             OFED_HARDWARE="$OFED_HARDWARE --with-ehca-mod"
1132             ;;
1133     esac
1134     # we're no longer shipping the OFED iSCSI target
1135     #OFED_ISCSI="--with-srp-mod --with-srp-target-mod"
1136     OFED_ISCSI="--with-srp-mod"
1137     ## ISER module has no backport support as of OFED 1.5 (i.e. only builds on
1138     ##kernels >= 2.6.30)
1139     #if [[ $OFED_VERSION = 1.[0-4]* ]]; then
1140     #   OFED_ISCSI="$OFED_ISCSI --with-iser-mod"
1141     #fi
1142
1143     # assume we are just rebuilding the SRPM
1144     local BUILD_TYPE=${BUILD_TYPE:-"--rebuild"}
1145     local SOURCE="${TOPDIR}/OFED/SRPMS/${kib_prefix}-*.src.rpm"
1146
1147     # but switch to building from the SPEC if we need to apply patches
1148     if ls ${TOPDIR}/lustre/contrib/patches/ofed/* >/dev/null; then
1149         BUILD_TYPE="-bb"
1150         rpm --define "_topdir ${TOPDIR}" -ivh $SOURCE
1151         SOURCE="${TOPDIR}/SPECS/${kib_prefix}.spec"
1152         local file ed_fragment1 ed_fragment2 n=1
1153         for file in $(ls ${TOPDIR}/lustre/contrib/patches/ofed/*.patch); do
1154             ed_fragment1="$ed_fragment1
1155 Patch$n: ${file%%*/}"
1156             ed_fragment2="$ed_fragment2
1157 %patch$n -p0"
1158             cp $file ${TOPDIR}/SOURCES
1159             let n=$n+1
1160         done
1161         for file in $(ls ${TOPDIR}/lustre/contrib/patches/ofed/*.ed); do
1162             # Only apply the ed-scripts that should be used for the canonical target
1163             # ed-files in ${TOPDIR}/lustre/contrib/patches/ofed/ have to follow the naming
1164             # convention
1165             # <two-digits>-<descriptive-name>:<canonical_target_1>: ...:<canonical_target_N>.ed
1166             # To apply the same change to multiple canonical target simply specify
1167             # a list of colon separated canoncial target names in the file name.
1168             echo "$file" | grep -q -e ":${CANONICAL_TARGET}:" \
1169                                    -e ":${CANONICAL_TARGET}.ed$"
1170             if [ $? -eq 0 ] ; then
1171                 ed_fragment3="$ed_fragment3
1172 $(cat $file)"
1173                 let n=$n+1
1174             fi
1175         done
1176
1177         if [ $n -gt 1 ]; then
1178             ed $SOURCE <<EOF
1179 /^Source: /a
1180 $ed_fragment1
1181 .
1182 /^%setup /a
1183 $ed_fragment2
1184 .
1185 $ed_fragment3
1186 wq
1187 EOF
1188         fi
1189     fi
1190
1191     local linuxrelease=$(find_linux_release)
1192     if compare_version $OFED_VERSION 3.0; then
1193         local OFA_KERNEL_RELEASE=$(echo -n ${linuxrelease} | sed -e 's/-/_/g')
1194     fi
1195     if ! $RPMBUILD $BUILD_TYPE --define 'build_kernel_ib 1' --define 'build_kernel_ib_devel 1' \
1196                   ${FIND_REQUIRES:+--define "__find_requires $FIND_REQUIRES"} \
1197                   --define "_topdir ${TOPDIR}" --target ${TARGET_ARCH} \
1198                   --define "KVERSION ${linuxrelease}" \
1199                   --define "$K_SRC ${linux}" \
1200                   --define "LIB_MOD_DIR /lib/modules/${linuxrelease}/updates" \
1201                   ${OFA_KERNEL_RELEASE:+--define "_release $OFA_KERNEL_RELEASE"} \
1202                   --define "configure_options --without-quilt $OFED_CORE $OFED_HARDWARE $OFED_ISCSI" \
1203                   ${SOURCE} 2>&1; then
1204         fatal 1 "Error building ${kib_rpm}"
1205     fi
1206
1207 }
1208
1209 store_for_reuse() {
1210     local articles="$1"
1211     local module="$2"
1212     local location="$3"
1213     local signature="$4"
1214     local use_links="$5"
1215
1216     local linkflag=""
1217     if $use_links; then
1218         linkflag="l"
1219     fi
1220
1221     local default_iface=$(/sbin/ip route get 192.1.1.1 | sed -ne 's/.* dev \(.*\)  * src .*/\1/p')
1222     if [ -z "$default_iface" ]; then
1223         fatal 1 "Failed to determine the default route interface"
1224     fi
1225     local unique_id=$(/sbin/ip addr show dev $default_iface | sed -ne '/ inet /s/ *inet \(.*\)\/.*/\1/p' | head -1)
1226     if [ -z "$unique_id" ]; then
1227         fatal 1 "Failed to determine a unique id from interface $default_interface"
1228     fi
1229
1230     local finallocation="$location"/"$signature"/"$module"
1231     location="$location"/"$signature-${unique_id}"/"$module"
1232     mkdir -p "$location"
1233     # the cleanup script removes any directory that doesn't have a
1234     # .lastused, so let's try to prevent that as soon as we can
1235     # this solution still slightly racy with the cleanup script
1236     # but the race is a lot tighter now
1237     touch -t 197001010000 "$location/.lastused"
1238     ## use eval/echo here to make sure shell expansions are performed
1239     #if ! cp -a${linkflag} $(eval echo $articles) "$location"; then
1240     local article
1241     for article in $(eval echo $articles); do
1242         if ! cp -a${linkflag} "$article" "$location"; then
1243             error "Failed to copy \"$article\" to \"$location\" in store_for_reuse()"
1244             # rename the cache location so that it's not cached
1245             # product, but is around for analysis
1246             mv "$location"{,-bad-$(date +%s)} ||
1247                 error "failed to clean up a failed cache attempt" \
1248                       "in \"$location\" -- manual cleanup will be" \
1249                       "necessary"
1250             return 1
1251         fi
1252     done
1253
1254     # flag the cache as complete (i.e. in case lbuild was previously
1255     # interrupted while caching)
1256     touch "$location/.lastused"
1257
1258     # put the temporary location into the final location
1259     # (last one wins)
1260     mkdir -p "${finallocation%/*}"
1261     mv "$location" "$finallocation"
1262     rmdir "${location%/*}"
1263     return 0
1264
1265 }
1266
1267 reuse() {
1268     local module="$1"
1269     local dest="$2"
1270     local use_links="${3:-false}"
1271     local signature="$4"
1272
1273     if [ -n "$REUSEBUILD" ] && [ -d "$REUSEBUILD/$signature/$module" ]; then
1274         if [ ! -f "$REUSEBUILD/$signature/$module/.lastused" ]; then
1275             # the .lastused flag is populated at the end of the caching to
1276             # signal that the caching was completed.  if that flag is not
1277             # there, then the cache is invalid (and should be removed in fact)
1278             mv "$REUSEBUILD/$signature/$module"{,-bad-$(date +%s)} ||
1279                 fatal 1 "failed to clean up a bad cache in location $REUSEBUILD/$signature/$module\" -- manual cleanup will be necessary"
1280             return 1
1281         fi
1282
1283         # so that we know how stale this entry is
1284         touch $REUSEBUILD/$signature/$module/.lastused
1285
1286         if $use_links; then
1287             if ls $REUSEBUILD/$signature/$module/* >/dev/null 2>&1; then
1288                 cp -al $REUSEBUILD/$signature/$module/* $dest/
1289             fi
1290         else
1291             # copying is pretty heavy
1292             # cp -a $REUSEBUILD/$signature/$module/* $dest/
1293             # do some creative symlinking instead
1294             local dir
1295             for dir in BUILD SRPMS SPECS; do
1296                 if ls $REUSEBUILD/$signature/$module/$dir/* >/dev/null 2>&1; then
1297                     ln -s $REUSEBUILD/$signature/$module/$dir/* $dest/$dir
1298                 fi
1299             done
1300             # sources have to be copied by file because we need SOURCES to
1301             # be a dir we can write into
1302 # could overrun ls's arg list here
1303             #ls $REUSEBUILD/$signature/$module/SOURCES/* |
1304             find $REUSEBUILD/$signature/$module/SOURCES/ -type f |
1305                 xargs ln -t $dest/SOURCES -s
1306
1307             # same for RPMS/* dirs
1308 # could overrun ls's arg list here
1309             #ls $REUSEBUILD/$signature/$module/RPMS/$TARGET_ARCH/* |
1310             local dir
1311             for dir in $REUSEBUILD/$signature/$module/RPMS/*; do
1312                 mkdir -p $dest/RPMS/${dir##*/}
1313                 find $dir -type f |
1314                   xargs ln -t $dest/RPMS/${dir##*/} -s
1315             done
1316         fi
1317         return 0
1318     else
1319         return 1
1320     fi
1321 }
1322
1323 basearch() {
1324     local arch="$1"
1325
1326     if [[ $arch = i[3456]86 ]]; then
1327         echo "i386"
1328     else
1329         echo "$arch"
1330     fi
1331
1332 }
1333
1334 build_kernel_with_srpm() {
1335     local outfd=$1
1336
1337     if [ -z "$outfd" ] || [ $outfd = 1 ]; then
1338         fatal 1 "You must supply a file descriptor to ${FUNCNAME[0]} and it cannot be 1"
1339     fi
1340
1341     # need to generate the patch for this target
1342     do_patch_linux false >&${outfd}    # sets global $FULL_PATCH (yeah, yuck)
1343
1344     # get an md5sum of the kernel patch + config for reuse check
1345     # XXX really, there needs to be a signature and a CONFIG_FILE per arch
1346     #     in BUILD_ARCHS
1347     local release_str
1348     if $RELEASE; then
1349         local release_str="RELEASE=$RELEASE\n"
1350     fi
1351
1352     if $USE_BUILD_CACHE && [ -n "$REUSEBUILD" ]; then
1353         local REUSE_SIGNATURE=$({ echo -en $release_str;
1354                                   echo $BUILD_GEN;
1355                                   cat "$CONFIG_FILE";
1356                                   cat "$TARGET_FILE";
1357                                   cat "$FULL_PATCH";
1358                                   cat "$LBUILD_DIR/lbuild";
1359                                   cat "$LBUILD_DIR/lbuild-$DISTROMAJ"; } |
1360                                 md5sum | cut -d" " -f1)
1361         # see if we can link to the reuse pool
1362         # XXX - hrm.  i'm not convinced this doesn't belong in the reuse
1363         #       "library"
1364         local CAN_LINK_FOR_REUSE=false
1365         touch $REUSEBUILD/$$
1366         if cp -al $REUSEBUILD/$$ $TOPDIR/ 2>/dev/null; then
1367             CAN_LINK_FOR_REUSE=true
1368         fi
1369         rm $REUSEBUILD/$$
1370     fi
1371
1372     # the extra version string to use for the kernel (which might be a reused
1373     # kernel, remember)
1374     local kernel_extra_version=""
1375     if ! $USE_BUILD_CACHE || ! reuse kernel "$TOPDIR" "$CAN_LINK_FOR_REUSE" \
1376                                    "$REUSE_SIGNATURE"; then
1377         # nothing cached, build from scratch
1378         if [ ! -r "$KERNELDIR/$KERNEL_SRPM" ]; then
1379             echo "Downloading kernel SRPM" >&${outfd}
1380             download_srpm "$CANONICAL_TARGET" "$KERNEL_SRPM" >&${outfd}
1381         fi
1382
1383         if ! rpm -ivh $KERNELDIR/$KERNEL_SRPM \
1384                   --define "_topdir $TOPDIR" >&${outfd} 2>&1; then
1385             # should we clean this up or leave it for analysis?
1386             #rm -rf $RPMTOPDIR
1387             fatal 1 "Error installing kernel SRPM."
1388         fi
1389
1390         # put the Lustre kernel patch into the RPM build tree
1391         cp $FULL_PATCH $TOPDIR/SOURCES/linux-${lnxmaj}-lustre.patch
1392         prepare_and_build_srpm >&${outfd} ||
1393             fatal 1 "failed to prepare_and_build_srpm"
1394
1395         if [ -z "$REUSE_SIGNATURE" ]; then
1396             echo "No reuse signature was caculated so not storing the built kernel" >&${outfd}
1397         else
1398             # store the resulting kernel RPM build tree for future use
1399             echo "Storing the built kernel for future reuse" >&${outfd}
1400             if ! store_for_reuse "$TOPDIR/{SPECS,SOURCES,SRPMS,RPMS}" \
1401                                  "kernel" "$REUSEBUILD" "$REUSE_SIGNATURE" \
1402                                  "$CAN_LINK_FOR_REUSE"; then
1403                 error "Failed to store kernel RPMS for reuse"
1404                 echo "unknown" >&${outfd}
1405                 return 1
1406             fi
1407         fi
1408     fi  # build reuse
1409
1410     # figure out the EXTRA_VERSION of the kernel we built or are re-using
1411     local KERNEL_RPM
1412     if ! KERNEL_RPM=$(find_rpm "$TOPDIR/RPMS/$TARGET_ARCH/" provides "^kernel(-default)? ="); then
1413         fatal 1 "Failed to find a kernel RPM in $TOPDIR/RPMS/$TARGET_ARCH/"
1414     fi
1415     kernel_extra_version=$(rpm -q --queryformat "%{RELEASE}" -p $TOPDIR/RPMS/$TARGET_ARCH/$KERNEL_RPM)
1416
1417     # should now have the following RPMs
1418     # $TOPDIR/RPMS/$arch/kernel-lustre-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1419     # $TOPDIR/RPMS/$arch/kernel-lustre-devel-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1420     # $TOPDIR/RPMS/$arch/kernel-lustre-headers-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1421     # $TOPDIR/RPMS/$arch/kernel-lustre-debuginfo-common-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1422     # $TOPDIR/RPMS/$arch/kernel-lustre-debuginfo-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1423
1424     echo $kernel_extra_version
1425     return 0
1426
1427 }
1428
1429 # build OFED
1430 # globals used:
1431 #    TOPDIR
1432 #    REUSEBUILD, USE_BUILD_CACHE
1433 #    CONFIGURE_FLAGS
1434
1435 build_ofed() {
1436     local linux="$1"
1437     local ofed_version="$2"
1438     local kib_prefix
1439     local kib_rpm
1440
1441     # if an ofed version is given, then it means use OFED proper,
1442     # not any vendor specific "inkernel" version
1443     if [ -z "$ofed_version" ]; then
1444         return 0
1445     fi
1446
1447     if [ "$ofed_version" = "inkernel" ]; then
1448         # see if there is a distro specific override for this and use
1449         # that if it exists
1450         # XXX we need to better integrate a distro specific override with
1451         #     the rest of this function so that all of the reuse cache
1452         #     stuff is leveraged given that 80% of this function is reuse
1453         if type -p build_ofed-$DISTROMAJ; then
1454             local ofed_location
1455             ofed_location=$(build_ofed-$DISTROMAJ ${STDOUT})
1456             local rc=${PIPESTATUS[0]}
1457             CONFIGURE_FLAGS="--with-o2ib=${ofed_location} ${CONFIGURE_FLAGS}"
1458             return $rc
1459         else
1460             return 0
1461         fi
1462     elif compare_version $OFED_VERSION 3.0; then
1463         kib_prefix="ofa_kernel"
1464         kib_rpm="kernel-ib"
1465     else
1466         kib_prefix="compat-rdma"
1467         kib_rpm="compat-rdma"
1468     fi
1469
1470     # build kernel-ib/compat-rdma
1471     if $USE_BUILD_CACHE && [ -n "$REUSEBUILD" ]; then
1472         local REUSE_SIGNATURE=$({ echo "$ofed_version";
1473                                   echo "$(find_linux_release;
1474                                   echo "$BUILD_GEN")";
1475                                   cat "${linux}/include/linux/autoconf.h";
1476                                   cat "$LBUILD_DIR/lbuild";
1477                                   cat "$LBUILD_DIR/lbuild-$DISTROMAJ"; } |
1478                                 md5sum | cut -d" " -f1)
1479         # see if we can link to the reuse pool
1480         # XXX - hrm.  i'm not convinced this doesn't belong in the reuse
1481         #       "library"
1482         local CAN_LINK_FOR_REUSE=false
1483         touch $REUSEBUILD/$$
1484         if cp -al $REUSEBUILD/$$ $TOPDIR/; then
1485             CAN_LINK_FOR_REUSE=true
1486         fi
1487         rm $REUSEBUILD/$$
1488     fi
1489
1490     if ! $USE_BUILD_CACHE || ! reuse ofed "$TOPDIR" "$CAN_LINK_FOR_REUSE" \
1491                                    "$REUSE_SIGNATURE"; then
1492         if [ -n "$REUSE_SIGNATURE" ]; then
1493             # stash away the existing built articles for a moment
1494             mkdir bak
1495             mv {BUILD,{S,}RPMS,S{OURCE,PEC}S} bak
1496             function mv_back {
1497                 pushd bak
1498                 find . | cpio -pudlm ..
1499                 popd
1500                 rm -rf bak
1501             }
1502             create_rpmbuild_dirs
1503         fi
1504         # build it
1505         build_kernel_ib "${linux}" "${kib_prefix}" "${kib_rpm}"
1506
1507         if [ -z "$REUSE_SIGNATURE" ]; then
1508             echo "No reuse signature was caculated so not storing the built ofed"
1509         else
1510             # store the resulting RPM build tree for future use
1511             echo "Storing the built ofed for future reuse"
1512             if ! store_for_reuse "$TOPDIR/{SPECS,SOURCES,BUILD,SRPMS,RPMS}" \
1513                                  "ofed" "$REUSEBUILD" "$REUSE_SIGNATURE" \
1514                                  "$CAN_LINK_FOR_REUSE"; then
1515                 error "Failed to store OFED RPMS for reuse"
1516                 mv_back
1517                 return 1
1518             fi
1519             # put the stuff we stashed away back
1520             mv_back
1521         fi
1522     fi
1523
1524     pushd "$TOPDIR" >/dev/null
1525     rm -rf ${kib_rpm}-devel
1526     mkdir ${kib_rpm}-devel
1527     cd ${kib_rpm}-devel
1528     # the actual ofed RPMs don't have the -rc$n or -$date string appened that
1529     # might be present on the file
1530     #local linuxrelease=$(find_linux_release)
1531     #ofed_version=$(echo $ofed_version |
1532     #               sed -re 's/-(20[0-9]{6,6}-[0-9]{4,4}|rc[0-9]*)$//')
1533     # FIXME
1534     # OFED version will have 'hyphen' for minor release. (e.g. 3.5-1, instead
1535     # of 3.5.1) compat-rdma and compat-rdma-devel could have same version
1536     # number, but currectly not. Once OFED fix this in the future release, we
1537     # can remove following filter.
1538     #ofed_version=$(echo $ofed_version |
1539     #               sed -re 's/-([0-9]*-[rR][cC][0-9]*)$//')
1540     #local rpm=$(ls $TOPDIR/RPMS/*/${kib_rpm}-devel-${ofed_version}-${linuxrelease//-/_}.*.rpm)
1541     # I dont' know why we have gone through the trouble to filter out the name
1542     # of the rpm there should only be one ${kib_rpm}-devel built
1543     local rpm=$(ls $TOPDIR/RPMS/*/${kib_rpm}-devel-*.rpm)
1544     if ! rpm2cpio < $rpm | cpio -id; then
1545         fatal 1 "could not unpack the ${kib_rpm}-devel rpm."
1546     fi
1547     CONFIGURE_FLAGS="--with-o2ib=$(pwd)/usr/src/${kib_prefix} ${CONFIGURE_FLAGS}"
1548     popd >/dev/null
1549
1550 }
1551
1552 build_with_srpm() {
1553
1554     if ! $PATCHLESS; then
1555         local kernel_extra_version
1556         if ! kernel_extra_version=$(build_kernel_with_srpm ${STDOUT}); then
1557             fatal 1 "Failed to build the kernel from it's SRPM"
1558         fi
1559
1560         for arch in $BUILD_ARCHS; do
1561             local kernel_devel_rpm
1562             if ! kernel_devel_rpm=$(find_rpm "$TOPDIR/RPMS/$arch/" provides "^$(devel_kernel_name $KERNEL_LUSTRE_NAMING) ="); then
1563                 fatal 1 "Failed to find a kernel development RPM in $TOPDIR/RPMS/$arch/"
1564             fi
1565
1566             # install the -devel RPM in preparation for modules builds
1567             if ! lnxrel="$kernel_extra_version" unpack_linux_devel_rpm \
1568                            "$TOPDIR/RPMS/$arch/$kernel_devel_rpm"; then
1569                 fatal 1 "Could not find the Linux tree in $TOPDIR/RPMS/$arch/$kernel_devel_rpm"
1570             fi
1571         done
1572     else
1573         # need to find and unpack the vendor's own kernel-devel for patchless
1574         # client build
1575         local kernelrpm
1576         if ! kernelrpm=$(find_linux_rpm "-$DEVEL_KERNEL_TYPE"); then
1577             fatal 1 "Could not find the kernel-$DEVEL_KERNEL_TYPE RPM in $KERNELRPMSBASE/$lnxmaj/$DISTROMAJ"
1578         fi
1579         if ! lnxrel="$lnxrel" unpack_linux_devel_rpm "$kernelrpm" "-"; then
1580             fatal 1 "Could not find the Linux tree in $kernelrpm"
1581         fi
1582     fi
1583
1584     # ~sigh~  have to make copies of and modify some of the rpm
1585     # infrastructure files so that find-requires can find our unpacked
1586     # kernel-devel artifacts
1587     cp $RPM_HELPERS_DIR/{symset-table,find-requires{,.ksyms}} .
1588     FIND_REQUIRES="$(pwd)/find-requires"
1589     chmod 755 {symset-table,find-requires{,.ksyms}}
1590     local tmp="$(pwd)"
1591     tmp="${tmp//\//\\/}"
1592     ed find-requires <<EOF
1593 1a
1594 set -x
1595 .
1596 /|.*find-requires.ksyms/s/|/| bash -x/
1597 g/ [^ ]*\/\(find-requires\.ksyms\)/s// $tmp\/\1/g
1598 wq
1599 EOF
1600     ed find-requires.ksyms <<EOF
1601 1a
1602 set -x
1603 .
1604 g/\/.*\/\(symset-table\)/s//$tmp\/\1/g
1605 wq
1606 EOF
1607     ed symset-table <<EOF
1608 1a
1609 set -x
1610 .
1611 g/\(\/boot\/\)/s//$tmp\/reused\1/g
1612 g/\(\/usr\/src\/kernels\/\)/s//$tmp\/reused\1/g
1613 wq
1614 EOF
1615
1616     build_ofed "${LINUXOBJ:-$LINUX}" "$OFED_VERSION" ||
1617         fatal 1 "error building OFED"
1618
1619     # now build Lustre
1620     if build_lustre "$LINUX" "$LINUXOBJ"; then
1621         # the build worked.  resolve any symlinked files (i.e. from reuse)
1622         # in RPMS/$arch to real files so that that that huge mess of
1623         # complication known as LTS can copy them yet somewhere else.
1624         # is it any wonder this whole process is so damn so?  anyone ever
1625         # heard of hardlinks?  it's this cool new thing that allows you save
1626         # tons of time and space by creating... well you can go read about
1627         # them if you have not heard about them yet.
1628         # can i say how much the implemenation of all of this really impedes
1629         # RPM reuse?
1630         local dir
1631         for dir in RPMS/*; do
1632             pushd $dir
1633             for file in $(ls); do
1634                 if [ -h $file ]; then
1635                     cp $file foo
1636                     mv foo $file
1637                 fi
1638             done
1639             popd
1640         done
1641         # also, for i?86, make sure all of the RPMs are in RPMS/$TARGET_ARCH
1642         # as that's where LTS expects to find them
1643         for dir in RPMS/*; do
1644             if [ $dir = RPMS/$TARGET_ARCH ]; then
1645                 continue
1646             fi
1647             pushd $dir
1648             local files=$(ls)
1649             if [ -n "$files" ]; then
1650                 cp -al $files ../$TARGET_ARCH
1651             fi
1652             popd
1653         done
1654     else
1655         return 1
1656     fi
1657
1658 }
1659
1660 create_rpmbuild_dirs() {
1661
1662     [ -d RPMS ] || mkdir RPMS
1663     for arch in $BUILD_ARCHS; do
1664         if [[ $arch = i?86 ]]; then
1665             # some stupidity in the sles11 kernel spec requires an RPMS/i386
1666             # even if the target arch is i686
1667             [ -d RPMS/i386 ] || mkdir RPMS/i386
1668         fi
1669         [ -d RPMS/$arch ] || mkdir RPMS/$arch
1670     done
1671     [ -d RPMS/noarch ] || mkdir RPMS/noarch
1672     [ -d BUILD ] || mkdir BUILD
1673     [ -d SOURCES ] || mkdir SOURCES
1674     [ -d SPECS ] || mkdir SPECS
1675     [ -d SRPMS ] || mkdir SRPMS
1676
1677 }
1678
1679 new_list() {
1680
1681     echo ""
1682
1683 }
1684
1685 add_list() {
1686     local list="$1"
1687     local item="$2"
1688
1689     echo "$list $item"
1690
1691 }
1692
1693 is_list_member() {
1694     local list="$1"
1695     local item="$2"
1696
1697     [[ $list\  == *\ $item\ * ]]
1698
1699 }
1700
1701 #########################################################################
1702 # Generate a backtrace through the call stack.
1703 #
1704 # Input: None
1705 # Output: None
1706 #########################################################################
1707 backtrace() {
1708     local strip=${1:-1}
1709
1710     local funcname="" sourcefile="" lineno="" n
1711
1712     echo "Call stack: (most recent first)"
1713     for (( n = $strip ; n < ${#FUNCNAME[@]} ; ++n )) ; do
1714         funcname=${FUNCNAME[$n - 1]}
1715         sourcefile=$(basename ${BASH_SOURCE[$n]})
1716         lineno=${BASH_LINENO[$n - 1]}
1717         if [ $n = 1 ]; then
1718             let lineno-=11
1719         fi
1720         # Display function arguments
1721         if [[ ! -z "${BASH_ARGV[@]}" ]]; then
1722             local args newarg j p=0
1723             for (( j = ${BASH_ARGC[$n - 1]}; j > 0; j-- )); do
1724                 newarg=${BASH_ARGV[$j + $p - 1]}
1725                 args="${args:+${args} }'${newarg}'"
1726             done
1727             let p+=${BASH_ARGC[$n - 1]}
1728         fi
1729         echo "  ${funcname} ${args:+${args} }at ${sourcefile}:${lineno}"
1730     done
1731
1732     echo
1733     echo "BEGIN BACKTRACE"
1734
1735     #echo ${BASH_LINENO[*]}
1736     #echo ${BASH_SOURCE[*]}
1737     #echo ${FUNCNAME[*]}
1738     local i=$((${#FUNCNAME[@]} - 1))
1739     while [ $i -ge 0 ]; do
1740         local lineno=${BASH_LINENO[$i]}
1741         if [ $i = 0 ]; then
1742             let lineno-=11
1743         fi
1744         local SOURCELINE="${BASH_SOURCE[$i + 1]}:${lineno}"
1745         # Can't figure out how to get function args from other frames...
1746         local FUNCTION="${FUNCNAME[$i]}()"
1747         echo "$SOURCELINE:$FUNCTION"
1748         i=$((i - 1))
1749     done
1750
1751     echo "END BACKTRACE"
1752
1753     echo $BACKTRACE
1754
1755 }
1756
1757 seen_list=$(new_list)
1758 trap 'set +x;
1759 echo "An unexpected error has occurred at ${BASH_SOURCE[0]##*/}:$((LINENO-1)).
1760 Unfortunately the above line number in the message may or may not be correct,
1761 but details have been send to the lbuild maintainer.  Attempting to continue."; (echo "Untrapped error"
1762 echo
1763 # have we seen this one
1764 echo "checking seen list for ${BASH_SOURCE[0]}:${BASH_LINENO[0]}"
1765
1766 if is_list_member "$seen_list" "${BASH_SOURCE[0]}:${BASH_LINENO[0]}"; then
1767   echo "seen this one already"
1768 else
1769   seen_list=$(add_list "$seen_list" "${BASH_SOURCE[0]}:${BASH_LINENO[0]}")
1770 fi
1771 backtrace
1772 ) ; set $xtrace' ERR
1773 set -E
1774
1775 [ -r ~/.lbuildrc ] && . ~/.lbuildrc
1776
1777 options=$(getopt -o D:h -l kerneltree:,distro:,kernelrpm:,reusebuild:,patchless,ccache,norpm,external-patches:,timestamp:,extraversion:,kerneldir:,linux:,lustre:,nodownload,nosrc,noiokit,ofed-version:,publish,disable-zfs,release,set-value:,src,stage:,target:,target-archs:,with-linux:,xen -- "$@")
1778
1779 if [ $? != 0 ]; then
1780     usage 1
1781 fi
1782
1783 eval set -- "$options"
1784
1785 while [ "$1" ]; do
1786     case "$1" in
1787         '')
1788             usage 1
1789             ;;
1790         --ccache)
1791             CCACHE='ccache'
1792             shift
1793             ;;
1794         -D)
1795             DATE=$2
1796             shift 2
1797             ;;
1798         --external-patches)
1799             EXTERNAL_PATCHES=$2
1800             shift 2
1801             ;;
1802         --extraversion)
1803             EXTRA_VERSION=$2
1804             shift 2
1805             ;;
1806         --help | -h)
1807             usage 0
1808             ;;
1809         --kerneldir)
1810             KERNELDIR=$2
1811             shift 2
1812             ;;
1813         --kerneltree)
1814             if ! KERNELTREE=$(canon_path "$2"); then
1815                 fatal 1 "Could not determine the canonical location of $2"
1816             fi
1817             shift 2
1818             ;;
1819         --linux | --with-linux)
1820             if ! LINUX=$(canon_path "$2"); then
1821                 fatal 1 "Could not determine the canonical location of $2"
1822             fi
1823             shift 2
1824             ;;
1825         --distro)
1826             DISTRO=$2
1827             shift 2
1828             ;;
1829         --reusebuild)
1830             if ! REUSEBUILD=$(canon_path "$2"); then
1831                 fatal 1 "Could not determine the canonical location of $2"
1832             fi
1833             shift 2
1834             ;;
1835         --norpm)
1836             NORPM=true
1837             shift
1838             ;;
1839         --noiokit)
1840             IOKITRPM=false
1841             shift
1842             ;;
1843         --patchless)
1844             PATCHLESS=true
1845             shift
1846             ;;
1847         --kernelrpm)
1848             if ! KERNELRPMSBASE=$(canon_path "$2"); then
1849                 fatal 1 "Could not determine the canonical location of $2"
1850             fi
1851             shift 2
1852             ;;
1853         --timestamp)
1854             TIMESTAMP=$2
1855             shift 2
1856             ;;
1857         --lustre)
1858             if ! LUSTRE=$(canon_filepath "$2"); then
1859                 fatal 1 "Could not determine the canonical location of $2"
1860             fi
1861             shift 2
1862             ;;
1863         --nodownload)
1864             DOWNLOAD=false
1865             shift 1
1866             ;;
1867         --nosrc)
1868             DO_SRC=false
1869             shift 1
1870             ;;
1871         --ofed-version)
1872             OFED_VERSION="$2"
1873             shift 2
1874             ;;
1875         --publish)
1876             shift
1877             ;;
1878         --disable-zfs)
1879             WITH_ZFS="no"
1880             shift
1881             ;;
1882         --release)
1883             RELEASE=true
1884             shift
1885             ;;
1886         --src)
1887             DO_SRC=true
1888             shift 1
1889             ;;
1890         --stage)
1891             STAGEDIR=$2
1892             shift 2
1893             ;;
1894         --target)
1895             TARGET=$2
1896             shift 2
1897             ;;
1898         --target-archs)
1899             TARGET_ARCHS=$2
1900             shift 2
1901             ;;
1902         --xen)
1903             XEN=true
1904             shift
1905             ;;
1906         --set-value)
1907             eval $2
1908             shift 2
1909             ;;
1910         --)
1911             shift
1912             # there are actually some lustre configure flags that we need to
1913             # handle ourselves (but we still give them to configure)
1914             if [[ \ $@\  == *\ --disable-tests\ * ]]; then
1915                 LUSTRE_TESTS=false
1916             fi
1917             CONFIGURE_FLAGS=$@
1918             break
1919             ;;
1920         *)
1921             usage 1 "Unrecognized option: $1"
1922             ;;
1923     esac
1924 done
1925
1926 check_options
1927
1928 unpack_lustre
1929
1930 # XXX - should we _always_ get the buildid from the META file?  what are the
1931 # other (i.e. non-lustre-tarball use cases of lbuild)?
1932 BUILDID=$(sed -n -e 's/^BUILDID = //p' lustre/META)
1933
1934 load_target
1935
1936 if [ -n "$OFED_VERSION" -a "$OFED_VERSION" != "inkernel" ]; then
1937     download_ofed
1938     unpack_ofed || fatal 1 "Error unpacking OFED tarball"
1939 fi
1940
1941 # make sure the RPM build environment is set up
1942 create_rpmbuild_dirs
1943
1944 # if an unpacked kernel source tree was given on the command line
1945 # just build lustre with it (nothing distro kernel specific here)
1946 if [ -n "$LINUX" ]; then
1947     find_linux_release() {
1948         _find_linux_release $LINUX
1949     }
1950     build_ofed "${LINUXOBJ:-$LINUX}" "$OFED_VERSION" ||
1951         fatal 1 "error building OFED"
1952     build_lustre "$LINUX" "$LINUXOBJ"
1953 else
1954     if [ ! -f "${LBUILD_DIR}/lbuild-$DISTROMAJ" ]; then
1955         fatal 1 "${LBUILD_DIR}/lbuild-$DISTROMAJ not found"
1956     fi
1957     source ${LBUILD_DIR}/lbuild-$DISTROMAJ
1958     build_with_srpm || fatal 1 "Failed to build_with_srpm"
1959 fi
1960
1961 stage